#Compile DLL "gbstl.dll"
#Dim All
'#Debug Error On     'catch array/pointer errors - OFF in production
'#Debug Display On   'display untrapped errors   - OFF in production
#Include "Win32API.inc"
#Include "cgdiplus.inc"

Type STLData
   hParent       As Dword
   hParentDC     As Dword
   CFN           As String * %Max_Path
   Details       As Long
   Shape         As Long
   Gradient      As Long
   PointColor    As Long
   LineColor     As Long
   TriangleColor As Long
   BGColor       As Long
   BackFaceCull  As Long
   DepthSort     As Long
   Orthographic  As Long
   PointSize     As Long
   MoveDistance  As Long
   ShowMarkers   As Long
   SurfaceLines  As Long
'   ScaleZ        As Single
   GradientDir   As Long
   ShowBGImage   As Long
   BGImageFit    As Long
End Type

Type PointX
    X As Single
    Y As Single
    Z As Single
    Xo As Single
    Yo As Single
    Zo As Single
    Xp As Single
    Yp As Single
    ColorG As Long : Marker As Long
End Type

Type TriangleX
    p1 As Long
    p2 As Long
    p3 As Long
    XDepthO As Single
    YDepthO As Single
    ZDepthO As Single
    ColorG As Long
    ZDepth As Single
    DotProduct As Single
End Type

Type Polypoints
    Count As Long
    x1 As Single : y1 As Single
    x2 As Single : y2 As Single
    x3 As Single : y3 As Single
End Type

Enum Equates Singular
   PreDraw          = 1000
   PostDraw         = 1001
   PointersChanged  = 1002

   Shape_Cube = 1
   Shape_Sphere
   Shape_File

   Details_Points = 1
   Details_Lines
   Details_Surfaces

   GradientX = 1
   GradientY
   GradientZ
   GradientXR
   GradientYR
   GradientZR
End Enum

Global hBMP, hDC, hBGImage As Dword
Global imgW, imgH As Long, imgWBG, imgHBG As Long
Global BGImage As StringZ * %Max_Path
Global P(), POnly() As PointX, T() As TriangleX, STL As STLData
Global OffsetX, OffsetY As Single, FarthestPoint As Long
Global PHighX, PLowX, PHighY, PLowY, PHighZ, PLowZ As Single
Global THighX, TLowX, THighY, TLowY, THighZ, TLowZ As Single

' Useful Macro functions
Macro Pi = 3.141592653589793##
Macro DegreesToRadians(dpDegrees) = (dpDegrees * 0.0174532925199433##)
Macro RadiansToDegrees(dpRadians) = (dpRadians * 57.29577951308232##)

'========================================================================

Sub stl_MoveUp Alias "stl_MoveUp" () Export
    Local i As Long
    For i = 1 To UBound(P)
        P(i).y = P(i).y - STL.MoveDistance: POnly(i).y = P(i).y
    Next i
End Sub

Sub stl_MoveDown Alias "stl_MoveDown" () Export
    Local i As Long
    For i = 1 To UBound(P)
        P(i).y = P(i).y + STL.MoveDistance : POnly(i).y = P(i).y
    Next i
End Sub

Sub stl_MoveLeft Alias "stl_MoveLeft" () Export
    Local i As Long
    For i = 1 To UBound(P)
        P(i).x = P(i).x - STL.MoveDistance : POnly(i).x = P(i).x
    Next i
End Sub

Sub stl_MoveRight Alias "stl_MoveRight" () Export
    Local i As Long
    For i = 1 To UBound(P)
        P(i).x = P(i).x + STL.MoveDistance : POnly(i).x = P(i).x
    Next i
End Sub

Sub stl_ChangeSize Alias "stl_ChangeSize" (Factor As Single) Export
    Local i As Long
    Factor = 1+Factor
    For i = 1 To UBound(P)
        P(i).x = P(i).x * Factor : POnly(i).x = P(i).x
        P(i).y = P(i).y * Factor : POnly(i).y = P(i).y
        P(i).z = P(i).z * Factor : POnly(i).z = P(i).z
    Next i
End Sub

Sub stl_ChangeZ Alias "stl_ChangeZ" (Factor As Single) Export
    Local i As Long
    For i = 1 To UBound(P)
        P(i).z = P(i).z * Factor : POnly(i).z = P(i).z
    Next i
End Sub

Sub PipeLine
    Local i As Long
    Graphic Attach hBMP, 0
    Graphic Get DC To hDC
    If STL.DepthSort Then
       If STL.Details = %Details_Points  Then SortPointsByZDepth
       If STL.Details = %Details_Lines   Then SortTrianglesByZDepth
       If STL.Details = %Details_Surfaces Then SortTrianglesByZDepth
    ElseIf STL.Details = 1 Then
       For i = 1 To UBound(P) : POnly(i) = P(i) : Next i
    End If
    If STL.BackFaceCull And STL.Details = %Details_Surfaces Then BackFaceCulling
    ProjectToScreen
    SendMessage STL.hParent, %WM_User+%PreDraw, 0, 0  'notify user of pending draw  'WM_User+1000
    DrawObject
    SendMessage STL.hParent, %WM_User+%PostDraw, 0, 0 'notify user that draw has completed  'WM_User+1001
End Sub

Sub stl_RotateAboutXAxis Alias "stl_RotateAboutXAxis" (Ang As Single) Export
   Local i As Long, NewY, NewZ As Single
   For i = 1 To UBound(P)
      NewY = P(i).Y * Cos(Ang) - P(i).Z * Sin(Ang)    'X rotation
      NewZ = P(i).Y * Sin(Ang) + P(i).Z * Cos(Ang)    'X rotation
      P(i).Y = NewY : P(i).Z = NewZ
   Next i
End Sub

Sub stl_RotateAboutYAxis Alias "stl_RotateAboutYAxis" (Ang As Single) Export
   Local i As Long, NewX, NewZ As Single
   For i = 1 To UBound(P)
      NewX = P(i).Z * Sin(Ang) + P(i).X * Cos(Ang)    'Y rotation
      NewZ = P(i).Z * Cos(Ang) - P(i).X * Sin(Ang)    'Y rotation
      P(i).X = NewX : P(i).Z = NewZ
   Next I
End Sub

Sub stl_RotateAboutZAxis Alias "stl_RotateAboutZAxis" (Ang As Single) Export
   Local i As Long, NewX, NewY As Single
   For i = 1 To UBound(P)
      NewX = P(i).X * Cos(Ang) - P(i).Y * Sin(Ang)    'Z rotation
      NewY = P(i).X * Sin(Ang) + P(i).Y * Cos(Ang)    'Z rotation
      P(i).X = NewX : P(i).Y = NewY
   Next i
End Sub

Sub SortPointsByZDepth
   Local i As Long
   For i = 1 To UBound(P) : POnly(i) = P(i) : Next i
   Array Sort POnly(1), Call CustomPointSort          'sort POnly
End Sub

Function CustomPointSort(R As PointX, S As PointX) As Long
   'sorts in ascending order by .z element
   If R.z < S.z Then Function = -1 : Exit Function
   If R.z > S.z Then Function = +1 : Exit Function
End Function

Sub SortTrianglesByZDepth
   Local i As Long
   If UBound(T) > 0 Then
      For i = 1 To UBound(T)
         T(i).ZDepth = (P(T(i).p1).Z + P(T(i).p2).Z + P(T(i).p3).Z) / 3
      Next i
      Array Sort T(1), Call CustomTriangleSort
   End If
End Sub

Function CustomTriangleSort(R As TriangleX, S As TriangleX) As Long
   'sorts in ascending order by .ZDepth element
   If R.ZDepth < S.ZDepth Then Function = -1 : Exit Function
   If R.ZDepth > S.ZDepth Then Function = +1 : Exit Function
End Function

Function BackFaceCulling() As Long
   'calculate z component of vector normal to the triangle. if > 0 is visible. If < 0 is not visible
   Local i As Long, x1,y1,x2,y2 As Long
    If UBound(T) > 0 Then
       For i = 1 To UBound(T)
          'cross product - defines a vector perpendicular to the triangle surface
          'uses right-hand rule of thumb rule, sequence of points defines the surface (counter-clockwise)
          'this code uses points P1P2 and P2P3 line segments - any 2 line segements from the triangle will do
          x1 = P(T(i).p3).X - P(T(i).p1).X
          y1 = P(T(i).p3).Y - P(T(i).p1).Y
          x2 = P(T(i).p3).X - P(T(i).p2).X
          y2 = P(T(i).p3).Y - P(T(i).p2).Y
          T(i).DotProduct = x1 * y2 - x2 * y1 'z component of cross product vector
       Next i
    End If
End Function

Function ProjectToScreen() As Long
   'currently uses only ORTHOGRAPHIC project. Does not support PERSPECTIVE projection
   Local i As Long
   For i = 1 To UBound(P)
      If STL.Details = %Details_Points Then    'points
         POnly(i).xp = POnly(i).x
         POnly(i).yp = POnly(i).y
      Else                   'lines and triangles
         P(i).xp = P(i).x
         P(i).yp = P(i).y
      End If
   Next i
End Function

Sub DrawObject()
   Local i,d,PColor,LColor,TColor As Long, x,y As Single, PTS As PolyPoints
   PTS.Count = 3

   If STL.ShowBGImage Then
      If STL.BGImageFit Then
         Graphic Stretch hBGImage, 0, (0,0)-(imgWBG-1,imgHBG-1) To (0,0)-(imgW-1,imgH-1), %Mix_CopySrc, %HalfTone
      Else
         Graphic Copy hBGImage, 0
      End If
   Else
      Graphic Clear STL.BGColor
   End If

   Select Case STL.Details
       Case %Details_Points     'points
          For i = 1 To UBound(POnly)
             If STL.Gradient Then PColor = POnly(i).ColorG Else PColor = STL.PointColor
             x = POnly(i).xp + OffsetX  : y = POnly(i).yp + OffsetY
             If STL.ShowMarkers Then
                Select Case POnly(i).marker
                   Case -1    : d = STL.PointSize + 4  : Graphic Ellipse (x-d,y-d)-(x+d,y+d), %Red, %Red, 0
                   Case 1     : d = STL.PointSize + 12 : Graphic Ellipse (x-d,y-d)-(x+d,y+d), %Green, %Green, 0
                   Case Else  : Graphic Ellipse (x-STL.PointSize,y-STL.Pointsize)-(x+STL.Pointsize,y+STL.Pointsize), PColor, PColor, 0
                End Select
             Else
                Graphic Ellipse (x-STL.PointSize,y-STL.Pointsize)-(x+STL.Pointsize,y+STL.Pointsize), PColor, PColor, 0
             End If
          Next i
       Case %Details_Lines     'lines
          If UBound(T) > 0 Then
             For i = 1 To UBound(T)
                If STL.Gradient Then LColor = T(i).ColorG Else LColor = STL.LineColor
                PTS.x1 = P(T(i).p1).xp + OffsetX : PTS.y1 = P(T(i).p1).yp + OffsetY
                PTS.x2 = P(T(i).p2).xp + OffsetX : PTS.y2 = P(T(i).p2).yp + OffsetY
                PTS.x3 = P(T(i).p3).xp + OffsetX : PTS.y3 = P(T(i).p3).yp + OffsetY
                Graphic Polygon PTS, LColor, -2, 0, 0              'Graphic Polyline PTS, LineColor
             Next i
          End If
       Case %Details_Surfaces      'surface
          If UBound(T) > 0 Then
             For i = 1 To UBound(T)
                If STL.Gradient Then TColor = T(i).ColorG Else TColor = STL.TriangleColor
                If STL.SurfaceLines Then LColor = STL.LineColor Else LColor = TColor
                PTS.x1 = P(T(i).p1).xp + OffsetX : PTS.y1 = P(T(i).p1).yp + OffsetY
                PTS.x2 = P(T(i).p2).xp + OffsetX : PTS.y2 = P(T(i).p2).yp + OffsetY
                PTS.x3 = P(T(i).p3).xp + OffsetX : PTS.y3 = P(T(i).p3).yp + OffsetY
                If STL.BackFaceCull Then
                   If T(i).DotProduct > 0 Then Graphic Polygon PTS, LColor, TColor, 0, 0
                Else
                   Graphic Polygon PTS, LColor, TColor, 0, 0
                End If
             Next i
          End If
   End Select
End Sub

Sub stl_LoadObjectFromFile Alias "stl_LoadObjectFromFile" (fName As String) Export
    MousePtr 11
    Local temp As String * 5
    Open fName For Binary As #1 : Get #1,, temp : Close #1
    If LCase$(temp) = "solid" Then LoadSTLAFile(fName) Else LoadSTLBFile(fName)
    MousePtr 0
End Sub

Sub LoadSTLBFile (fName As String)
   On Error GoTo STLBError

   Local temp As String * 80
   Local x,y,z As Single
   Local i, iPoints As Long
   Local iCount As Dword
   Local iSkip As Integer

   Open fName For Binary As #1
   Get #1, , temp
   Get #1, , iCount
   ReDim P(iCount*3)
   ReDim POnly(iCount*3)
   ReDim T(iCount)
   NotifyUserThatPointersHaveChanged

   For i = 1 To iCount
       Get #1, , x : Get #1, , y : Get #1, , z  'discard

       Incr iPoints
       Get #1, , P(iPoints).x : Get #1, , P(iPoints).y : Get #1, , P(iPoints).z
       T(i).p1 = iPoints

       Incr iPoints
       Get #1, , P(iPoints).x : Get #1, , P(iPoints).y : Get #1, , P(iPoints).z
       T(i).p2 = iPoints

       Incr iPoints
       Get #1, , P(iPoints).x : Get #1, , P(iPoints).y : Get #1, , P(iPoints).z
       T(i).p3 = iPoints

       Get #1, , iSkip
   Next i
   Close #1
   For i = 1 To UBound(P)
      P(i).xo = P(i).x : POnly(i).x = P(i).x
      P(i).yo = P(i).y : POnly(i).y = P(i).y
      P(i).zo = P(i).z : POnly(i).z = P(i).z
   Next i
   P(1).Marker = -1 : P(UBound(P)).Marker = 1
   GetFarthestPoint
   stl_SetPointHighLow
   stl_SetPointGradientColors
   SetTriangleHighLow
   stl_SetTriangleGradientColors
   'If STL.ScaleZ Then ApplyScaleZ
   Exit Sub

STLBError:
Close #1
? "STLB Error: " + $CrLf + Err$ + $CrLf + fName$
End Sub

Sub LoadSTLAFile (fName As String)
   On Error GoTo STLAError

    Local temp As String, i, iCount, iPoints, iTriangles As Long

    'verify file is right type
    Open fName For Input As #1
    Line Input #1, temp
    Close #1
    If Left$(LCase$(Trim$(temp)),5) <> "solid" Then Exit Sub

    'get count # Points and # triangles
    Open fName For Binary As #1
    Get$ #1, Lof(1), temp
    Close #1
    iCount = ParseCount(LCase$(temp), "endfacet") - 1
    ReDim P(iCount*3)
    ReDim POnly(iCount*3)
    ReDim T(iCount)
    NotifyUserThatPointersHaveChanged

    'load into P(), POnly(), T()
    Open fName For Input As #1
    Line Input #1, temp    'header, discard
    For i = 1 To iCount
        Incr iTriangles

        Line Input #1, temp 'discard
        Line Input #1, temp 'discard

        Line Input #1, temp 'p1
           temp = Trim$(temp)
           Incr iPoints
           While InStr(temp, "  ") : Replace "  " With " " In temp : Wend   'remove extra spaces
           P(iPoints).x = Val(Parse$(temp," ",2)) : POnly(iPoints).x = P(iPoints).x
           P(iPoints).y = Val(Parse$(temp," ",3)) : POnly(iPoints).y = P(iPoints).y
           P(iPoints).z = Val(Parse$(temp," ",4)) : Ponly(iPoints).z = P(iPoints).z
           T(iTriangles).p1 = iPoints

        Line Input #1, temp 'p2
           temp = Trim$(temp)
           Incr iPoints
           While InStr(temp, "  ") : Replace "  " With " " In temp : Wend   'remove extra spaces
           P(iPoints).x = Val(Parse$(temp," ",2)) : POnly(iPoints).x = P(iPoints).x
           P(iPoints).y = Val(Parse$(temp," ",3)) : POnly(iPoints).y = P(iPoints).y
           P(iPoints).z = Val(Parse$(temp," ",4)) : Ponly(iPoints).z = P(iPoints).z
           T(iTriangles).p2 = iPoints

        Line Input #1, temp 'p3
           temp = Trim$(temp)
           Incr iPoints
           While InStr(temp, "  ") : Replace "  " With " " In temp : Wend   'remove extra spaces
           P(iPoints).x = Val(Parse$(temp," ",2)) : POnly(iPoints).x = P(iPoints).x
           P(iPoints).y = Val(Parse$(temp," ",3)) : POnly(iPoints).y = P(iPoints).y
           P(iPoints).z = Val(Parse$(temp," ",4)) : Ponly(iPoints).z = P(iPoints).z
           T(iTriangles).p3 = iPoints

        Line Input #1, temp ' discard
        Line Input #1, temp ' discard

    Next i
    Close #1

   For i = 1 To UBound(P)
      P(i).xo = P(i).x : POnly(i).x = P(i).x
      P(i).yo = P(i).y : POnly(i).y = P(i).y
      P(i).zo = P(i).z : POnly(i).z = P(i).z
   Next i
   P(1).Marker = -1 : P(UBound(P)).Marker = 1
   GetFarthestPoint
   stl_SetPointHighLow
   stl_SetPointGradientColors
   SetTriangleHighLow
   stl_SetTriangleGradientColors
   'If STL.ScaleZ Then ApplyScaleZ
   Exit Sub

STLAError:
Close #1
? "STLA Error: " + $CrLf + Err$ + $CrLf + fName$
End Sub

Sub stl_Reset Alias "stl_Reset" () Export
   Local i As Long
   For i = 1 To UBound(P)
      P(i).x = P(i).xo : P(i).y = P(i).yo : P(i).z = P(i).zo
      POnly(i).x = P(i).xo : POnly(i).y = P(i).yo : POnly(i).z = P(i).zo
   Next i
End Sub

Sub stl_CreateCube Alias "stl_CreateCube" () Export
   Local i As Long
   ReDim P(8)
   ReDim POnly(8)
   ReDim T(12)
   NotifyUserThatPointersHaveChanged
   P(1).x = -50  : P(1).y = -50  : P(1).z = -50
   P(2).x = -50  : P(2).y =  50  : P(2).z = -50
   P(3).x =  50  : P(3).y =  50  : P(3).z = -50
   P(4).x =  50  : P(4).y = -50  : P(4).z = -50
   P(5).x = -50  : P(5).y = -50  : P(5).z =  50
   P(6).x = -50  : P(6).y =  50  : P(6).z =  50
   P(7).x =  50  : P(7).y =  50  : P(7).z =  50
   P(8).x =  50  : P(8).y = -50  : P(8).z =  50
   T(1).p1 = 1 : T(1).p2 = 3 : T(1).p3 = 4
   T(2).p1 = 1 : T(2).p2 = 2 : T(2).p3 = 3
   T(3).p1 = 5 : T(3).p2 = 2 : T(3).p3 = 1
   T(4).p1 = 5 : T(4).p2 = 6 : T(4).p3 = 2
   T(5).p1 = 8 : T(5).p2 = 6 : T(5).p3 = 5
   T(6).p1 = 8 : T(6).p2 = 7 : T(6).p3 = 6
   T(7).p1 = 4 : T(7).p2 = 7 : T(7).p3 = 8
   T(8).p1 = 4 : T(8).p2 = 3 : T(8).p3 = 7
   T(9).p1 = 3 : T(9).p2 = 6 : T(9).p3 = 7
   T(10).p1 = 3 : T(10).p2 = 2 : T(10).p3 = 6
   T(11).p1 = 4 : T(11).p2 = 5 : T(11).p3 = 1
   T(12).p1 = 4 : T(12).p2 = 8 : T(12).p3 = 5

    For i = 1 To UBound(P)
       P(i).xo = P(i).x : POnly(i).x = P(i).x
       P(i).yo = P(i).y : POnly(i).y = P(i).y
       P(i).zo = P(i).z : POnly(i).z = P(i).z
    Next i
   P(1).Marker = -1 : P(UBound(P)).Marker = 1
   GetFarthestPoint
   stl_SetPointHighLow
   stl_SetPointGradientColors
   SetTriangleHighLow
   stl_SetTriangleGradientColors
   stl_RotateAboutXAxis Pi/2
   'If STL.ScaleZ Then ApplyScaleZ
End Sub

Sub stl_CreateSphere Alias "stl_CreateSphere" () Export
   Local i, j, iCount, TCount, iLayers, iDivisions  As Long
   Local SAngle, Radius, z, zStep, tempS As Single
   iLayers = 20 : iDivisions = 20 : Radius = 100 : iCount = 1
   ReDim P(iLayers * iDivisions + 2)    'position P(0) is reserved
   ReDim POnly(iLayers * iDivisions + 2)    'position P(0) is reserved
   ReDim T((iLayers-1)*iDivisions*2 + 4*iDivisions)
   NotifyUserThatPointersHaveChanged

   SAngle = 6.28 / iDivisions   '1 radian = 57.2957 degrees : 1 degree = 0.0174532 radians
   zStep = 2 * Radius / (iLayers+1)

   'Points
   P(iCount).x = 0 : P(iCount).y = 0 : P(iCount).z = Radius
   P(UBound(P)).x = 0 : P(UBound(P)).y = 0 : P(UBound(P)).z = -1 * Radius
   For i = 1 To iLayers
      z = Radius - zStep * i
      tempS = Sqr(Radius*Radius - z*z)
      For j = 0 To iDivisions - 1
         iCount = iCount + 1
         P(iCount).x = tempS * Sin(j*SAngle)
         P(iCount).y = tempS * Cos(j*SAngle)
         P(iCount).z = z
      Next j
   Next i

   For i = 1 To UBound(P)
      P(i).xo = P(i).x : POnly(i).x = P(i).x
      P(i).yo = P(i).y : POnly(i).y = P(i).y
      P(i).zo = P(i).z : POnly(i).z = P(i).z
   Next i

   'triangles
   'top layer
   For i = 2 To iDivisions
      Incr TCount  :   T(TCount).p1 = 1  :  T(TCount).p2 = i+1 :  T(TCount).p3 = i
   Next i
   Incr TCount  :   T(TCount).p1 = 1  :  T(TCount).p2 = 2 :  T(TCount).p3 = iDivisions + 1

   'bottom layer
   For i = UBound(P)-iDivisions To UBound(P)-1
      Incr TCount  :   T(TCount).p1 = UBound(P) :  T(TCount).p2 = i :  T(TCount).p3 = i+1
   Next i
   Incr TCount  :   T(TCount).p1 = UBound(P)  :  T(TCount).p2 = UBound(P)-1 :  T(TCount).p3 = UBound(P)-iDivisions

   'other layers
   For i = 1 To iLayers-1
      iCount = (i-1)*iDivisions + 1
      'most divisions
      For j = 1 To iDivisions -1
         Incr TCount
         T(TCount).p1 = j + iCount
         T(TCount).p2 = T(TCount).p1 + iDivisions + 1
         T(TCount).p3 = T(TCount).p1 + iDivisions
         Incr TCount
         T(TCount).p1 = j + iCount
         T(TCount).p2 = T(TCount).p1 + 1
         T(TCount).p3 = T(TCount).p1 + iDivisions + 1
      Next j
      'last division
      Incr TCount
      T(TCount).p1 = iDivisions + iCount
      T(TCount).p2 = 1 + iCount + iDivisions
      T(TCount).p3 = iCount + iDivisions + iDivisions
      Incr TCount
      T(TCount).p1 = iDivisions + iCount
      T(TCount).p2 = 1 + iCount
      T(TCount).p3 = 1 + iCount + iDivisions
   Next i
   P(1).Marker = -1 : P(UBound(P)).Marker = 1
   GetFarthestPoint
   stl_SetPointHighLow
   stl_SetPointGradientColors
   SetTriangleHighLow
   stl_SetTriangleGradientColors
   'If STL.ScaleZ Then ApplyScaleZ
End Sub

Sub stl_SetPointGradientColors Alias "stl_SetPointGradientColors" () Export
   Local i As Long
   Select Case STL.GradientDir
      Case %GradientX  : For i = 1 To UBound(P) : P(i).ColorG = GradientColor(P(i).xo, PHighX, PLowX) :  POnly(i).ColorG = P(i).ColorG : Next i
      Case %GradientY  : For i = 1 To UBound(P) : P(i).ColorG = GradientColor(P(i).yo, PHighY, PLowY) :  POnly(i).ColorG = P(i).ColorG : Next i
      Case %GradientZ  : For i = 1 To UBound(P) : P(i).ColorG = GradientColor(P(i).zo, PHighZ, PLowZ) :  POnly(i).ColorG = P(i).ColorG : Next i
      Case %GradientXR : For i = 1 To UBound(P) : P(i).ColorG = GradientColor(P(i).xo, PLowX, PHighX) :  POnly(i).ColorG = P(i).ColorG : Next i
      Case %GradientYR : For i = 1 To UBound(P) : P(i).ColorG = GradientColor(P(i).yo, PLowY, PHighY) :  POnly(i).ColorG = P(i).ColorG : Next i
      Case %GradientZR : For i = 1 To UBound(P) : P(i).ColorG = GradientColor(P(i).zo, PLowZ, PHighZ) :  POnly(i).ColorG = P(i).ColorG : Next i
   End Select
End Sub

Sub stl_SetPointHighLow Alias "stl_SetPointHighLow" () Export
   Local i As Long
   If UBound(p) = -1 Then
       PHighX = 0: PLowX = 0: PHighY = 0: PLowY = 0: PHighZ = 0: PLowZ = 0
   Else
       PHighX = P(1).x: PLowX = P(1).x
       PHighY = P(1).y: PLowY = P(1).y
       PHighZ = P(1).z: PLowZ = P(1).z
       For i = 2 To UBound(P)
           If P(i).x > PHighX Then PHighX = P(i).x
           If P(i).x < PLowX Then PLowX = P(i).x

           If P(i).y > PHighY Then PHighY = P(i).y
           If P(i).y < PLowY Then PLowY = P(i).y

           If P(i).z > PHighZ Then PHighZ = P(i).z
           If P(i).z < PLowZ Then PLowZ = P(i).z
       Next i
   End If
End Sub


Sub XSetPointHighLow()
   Local i As Long
   If UBound(p) = -1 Then
       PHighX = 0: PLowX = 0: PHighY = 0: PLowY = 0: PHighZ = 0: PLowZ = 0
   Else
       PHighX = P(1).xo: PLowX = P(1).xo
       PHighY = P(1).yo: PLowY = P(1).yo
       PHighZ = P(1).zo: PLowZ = P(1).zo
       For i = 2 To UBound(P)
           If P(i).xo > PHighX Then PHighX = P(i).xo
           If P(i).xo < PLowX Then PLowX = P(i).xo

           If P(i).yo > PHighY Then PHighY = P(i).yo
           If P(i).yo < PLowY Then PLowY = P(i).yo

           If P(i).zo > PHighZ Then PHighZ = P(i).zo
           If P(i).zo < PLowZ Then PLowZ = P(i).zo
       Next i
   End If
End Sub

Sub stl_SetTriangleGradientColors Alias "stl_SetTriangleGradientColors" () Export
   Local i As Long
   Select Case STL.GradientDir
      Case %GradientX  : For i = 1 To UBound(T) : T(i).ColorG = GradientColor(T(i).XDepthO, THighX, TLowX) : Next i
      Case %GradientY  : For i = 1 To UBound(T) : T(i).ColorG = GradientColor(T(i).YDepthO, THighY, TLowY) : Next i
      Case %GradientZ  : For i = 1 To UBound(T) : T(i).ColorG = GradientColor(T(i).ZDepthO, THighZ, TLowZ) : Next i
      Case %GradientXR : For i = 1 To UBound(T) : T(i).ColorG = GradientColor(T(i).XDepthO, TLowX, THighX) : Next i
      Case %GradientYR : For i = 1 To UBound(T) : T(i).ColorG = GradientColor(T(i).YDepthO, TLowY, THighY) : Next i
      Case %GradientZR : For i = 1 To UBound(T) : T(i).ColorG = GradientColor(T(i).ZDepthO, TLowZ, THighZ) : Next i
   End Select
End Sub

Sub SetTriangleHighLow()
   Local i As Long
   If UBound(T) < 1 Then
       THighX = 0: TLowX = 0
       THighY = 0: TLowY = 0
       THighZ = 0: TLowZ = 0
   Else
      T(1).XDepthO = (P(T(1).p1).X + P(T(1).p2).X + P(T(1).p3).X) / 3
      THighX = T(1).XDepthO : TLowX = T(1).XdepthO

      T(1).YDepthO = (P(T(1).p1).Y + P(T(1).p2).Y + P(T(1).p3).Y) / 3
      THighY = T(1).YDepthO : TLowY = T(1).YdepthO

      T(1).ZDepthO = (P(T(1).p1).Z + P(T(1).p2).Z + P(T(1).p3).Z) / 3
      THighZ = T(1).ZDepthO : TLowZ = T(1).ZdepthO
      For i = 2 To UBound(T)
         T(i).XDepthO = (P(T(i).p1).X + P(T(i).p2).X + P(T(i).p3).X) / 3
         If T(i).XDepthO > THighX Then THighX = T(i).XDepthO
         If T(i).XDepthO < TLowX Then TLowX = T(i).XDepthO

         T(i).YDepthO = (P(T(i).p1).Y + P(T(i).p2).Y + P(T(i).p3).Y) / 3
         If T(i).YDepthO > THighY Then THighY = T(i).YDepthO
         If T(i).YDepthO < TLowY Then TLowY = T(i).YDepthO

         T(i).ZDepthO = (P(T(i).p1).Z + P(T(i).p2).Z + P(T(i).p3).Z) / 3
         If T(i).ZDepthO > THighZ Then THighZ = T(i).ZDepthO
         If T(i).ZDepthO < TLowZ Then TLowZ = T(i).ZDepthO
      Next i
   End If
End Sub

Function GradientColor(Height As Single, ByVal HiValue As Single, ByVal LoValue As Single) As Long
   'returns Long color, and RGB components, across the entire spectrum based on position of a number between two limits
   Local CRatio As Single, Exponent As Single, LoV, HiV As Single
   Local R,G,B As Long
   Exponent = 0.365

   If HiValue <> LoValue Then
       CRatio = Abs((Height - LoValue) / (HiValue - LoValue))
   Else
       CRatio = 0
   End If

   If CRatio > 1 Then CRatio = 1
   If CRatio < 0 Then CRatio = 0

   Select Case CRatio
       Case Is < 0.25
           r = 0
           g = 255 * (((CRatio - 0) * 4) ^ Exponent)
           b = 255
       Case Is < 0.5
           r = 0
           g = 255
           b = 255 * ((1 - (CRatio - 0.25) * 4) ^ Exponent)
       Case Is < 0.75
           r = 255 * (((CRatio - 0.5) * 4) ^ Exponent)
           g = 255
           b = 0
       Case Else
           r = 255
           g = 255 * ((1 - (CRatio - 0.75) * 4) ^ Exponent)
           b = 0

   End Select
   Function = RGB(r, g, b)

End Function

Sub stl_Render Alias "stl_Render" (NewSTL As STLData) Export
   If UBound(P) = -1 Then Exit Sub
   STL           = NewSTL  'multiple variables
   PipeLine
   Bitblt  STL.hParentDC,0,0,imgW, imgH, hDC,0,0, %srccopy
End Sub

Sub stl_ResizeImage Alias "stl_ResizeImage" (w As Long, h As Long) Export
   imgW = w : imgH = h
   If hBMP Then Graphic Attach hBMP,0 : Graphic Bitmap End
   Graphic Bitmap New imgW, imgH To hBMP
   OffSetX = imgW/2
   OffSetY = imgH/2
   Graphic Attach hBMP, 0
   Graphic Get DC To hDC
End Sub

Sub GetFarthestPoint
   Local i As Long, pDistance, maxDistance As Single
   FarthestPoint = 1
   For i = 1 To UBound(P)
      pDistance = Sqr(P(i).x*P(i).x + P(i).y*P(i).y + P(i).z*P(i).z)
      If maxDistance < pDistance Then FarthestPoint = i : maxDistance = pDistance
   Next i
End Sub

Sub stl_CenterModel Alias "stl_CenterModel" () Export
   Local i As Long
   Local CenterX, CenterY, CenterZ As Single
   CenterX = (PHighX + PLowX)/2
   CenterY = (PHighY + PLowY)/2
   CenterZ = (PHighZ + PLowZ)/2

   'move all nodes to center position
   For i = 1 To UBound(P)
      P(i).x = (P(i).x - CenterX) : POnly(i).x = P(i).x
      P(i).y = (P(i).y - CenterY) : POnly(i).y = P(i).y
      P(i).z = (P(i).z - CenterZ) : POnly(i).z = P(i).z
   Next i
End Sub

Sub stl_ScaleToFit Alias "stl_ScaleToFit" () Export
   Local w,h As Long, ScaleFactor, FarthestDistance As Single
   'get farthest point to use for setting scalefactor
   FarthestDistance = Sqr(P(FarthestPoint).x*P(FarthestPoint).x + P(FarthestPoint).y*P(FarthestPoint).y + P(FarthestPoint).z*P(FarthestPoint).z)
   Graphic Get Canvas To w,h
   If h < w Then ScaleFactor = h /(2*FarthestDistance)*0.9 Else ScaleFactor = w/(2*FarthestDistance)*0.9
   'scale points to fit within graphic control
   stl_ChangeSize (ScaleFactor-1)
End Sub

Function stl_GetPointCount Alias "stl_GetPointCount" () Export As Long
   Function = UBound(P)
End Function

Function stl_GetDLLVersion Alias "stl_GetDLLVersion" () Export As String
   Function = "2.0"
End Function

Function stl_GetTriangleCount Alias "stl_GetTriangleCount" () Export As Long
   Function = UBound(T)
End Function

Sub stl_GetDataPointers Alias "stl_GetDataPointers" (pPtr As Dword, pDims As Long, tPtr As Dword, tDims As Long) Export
   pPtr = VarPtr(P(0)) : pDims = UBound(p)
   tPtr = VarPtr(T(0)) : tDims = UBound(t)
End Sub

Sub stl_GetDataArrays Alias "stl_GetDataArrays" (tempP() As PointX, tempT() As TriangleX) Export
   Local i As Long
   For i = 1 To UBound(P) : tempP(i) = P(i) : Next i
   For i = 1 To UBound(T) : tempT(i) = T(i) : Next i
End Sub

Sub stl_SetGradientDir Alias "stl_SetGradientDir" (gDir As Long) Export
   STL.GradientDir = gDir
End Sub

Sub stl_SetData Alias "stl_SetData" (tempP() As PointX, tempT() As TriangleX) Export
   Local i As Long
   For i = 1 To UBound(P) : P(i) = tempP(i) : Next i
   For i = 1 To UBound(T) : T(i) = tempT(i) : Next i
End Sub

'Sub ApplyScaleZ
'   Local i As Long
'   For i = 1 To UBound(P)
'      P(i).zo     = P(i).zo + STL.ScaleZ * (P(i).zo-PLowZ)
'      P(i).z      = P(i).zo
'      POnly(i).z  = P(i).zo
'   Next i
'End Sub

Sub NotifyUserThatPointersHaveChanged
    SendMessage STL.hParent, %WM_User+%PointersChanged, 0, 0  'alerts user that pointer has changed
End Sub

Sub stl_LoadBGImage Alias "stl_LoadBGImage" (BGImage As StringZ * %Max_Path) Export
   'load JPG/GIF/PNG image to memory bitmap from file
   Local pImage,pGraphics,token,hDCBGImage As Dword, StartupInput As GdiplusStartupInput

   If hBGImage Then Graphic Attach hBGImage, 0 : Graphic Bitmap End  'get rid of the existing bitmap, if one exists

   'initialize GDIPlus
   StartupInput.GdiplusVersion = 1
   GdiplusStartup(token, StartupInput, ByVal %NULL)

   'load image/get properties
   GdipLoadImageFromFile((BGImage), pImage)          'pImage - image object
   GdipGetImageWidth(pImage,imgWBG)                      'get width
   GdipGetImageHeight(pImage,imgHBG)                     'get height

   'put in Graphic Memory Bitmap
   Graphic Bitmap New imgWBG,imgHBG To hBGImage
   Graphic Attach hBGImage,0
   Graphic Get DC To hDCBGImage                               'hDC is for memory bitmap

   GdipCreateFromHDC(hDCBGImage, pGraphics)                   'create graphic object
   GdipDrawImageRect(pGraphics, pImage, 0,0,imgWBG,imgHBG)    'draw image at 0,0

   'cleanup
   If pImage Then GdipDisposeImage(pImage)             'GDIP cleanup
   If pGraphics Then GdipDeleteGraphics(pGraphics)     'GDIP cleanup
   GdiplusShutdown token                               'Shutdown GDI+
End Sub
