'Compilable Example:
#Compiler PBWin 10
#Compile Exe "gbSTLDemo.exe"
#Dim All
'#Debug Display On
'#Debug Error On
%Unicode = 1
#Include "Win32API.inc"
$Ver = "2.0"

#Resource Icon logo, "icons\stl.ico"
#Resource Icon xopen, "icons\open.ico"
#Resource Icon xreset, "icons\reset.ico"
#Resource Icon xcopy, "icons\copy.ico"
#Resource Icon xsettings, "icons\settings.ico"
#Resource Icon xhelp, "icons\help.ico"
#Resource Icon xlines, "icons\lines.ico"
#Resource Icon xpoints, "icons\points.ico"
#Resource Icon xtriangles, "icons\triangles.ico"
#Resource Icon xx, "icons\x.ico"
#Resource Icon xy, "icons\y.ico"
#Resource Icon xz, "icons\z.ico"
#Resource Icon xgradient, "icons\gradient.ico"
#Resource Icon xspin, "icons\spin.ico"
#Resource Icon xshowdata, "icons\showdata.ico"
#Resource Icon xrefresh, "icons\refresh.ico"
#Resource Icon ximage, "icons\image.ico"

Type CustomColors
   c(15) As Long    'custom colors
End Type

Type STLData
   hParent       As Dword
   hParentDC     As Dword
   CFN           As StringZ * %Max_Path
   Details       As Long
   Shape         As Long
   Gradient      As Long
   PointColor    As Long
   LineColor     As Long
   TriangleColor As Long
   BGColor       As Long
   BackFaceCull  As Long
   DepthSort     As Long
   Orthographic  As Long
   PointSize     As Long
   MoveDistance  As Long
   ShowMarkers   As Long
   SurfaceLines  As Long
'   ScaleZ        As Single
   GradientDir   As Long
   ShowBGImage   As Long
   BGImageFit    As Long
End Type

Type PointX
    X As Single
    Y As Single
    Z As Single
    Xo As Single
    Yo As Single
    Zo As Single
    Xp As Single
    Yp As Single
    ColorG As Long : Marker As Long
End Type

Type TriangleX
    p1 As Long
    p2 As Long
    p3 As Long
    XDepthO As Single
    YDepthO As Single
    ZDepthO As Single
    ColorG As Long
    ZDepth As Single
    DotProduct As Single
End Type

Declare Sub stl_Render                 Lib "gbstl.dll" Alias "stl_Render" (STL As STLData)
Declare Sub stl_Reset                  Lib "gbstl.dll" Alias "stl_Reset"

Declare Sub stl_ResizeImage            Lib "gbstl.dll" Alias "stl_ResizeImage" (imgW As Long, imgH As Long)
Declare Sub stl_CenterModel            Lib "gbstl.dll" Alias "stl_CenterModel" ()
Declare Sub stl_SetPointHighLow        Lib "gbstl.dll" Alias "stl_SetPointHighLow" ()
Declare Sub stl_ScaleToFit             Lib "gbstl.dll" Alias "stl_ScaleToFit" ()
Declare Sub stl_ChangeSize             Lib "gbstl.dll" Alias "stl_ChangeSize" (ScaleFactor As Single)
'Declare Sub stl_ChangeZ                Lib "gbstl.dll" Alias "stl_ChangeZ" (ScaleFactor As Single)

Declare Sub stl_RotateAboutXAxis       Lib "gbstl.dll" Alias "stl_RotateAboutXAxis" (Angle As Single)
Declare Sub stl_RotateAboutYAxis       Lib "gbstl.dll" Alias "stl_RotateAboutYAxis" (Angle As Single)
Declare Sub stl_RotateAboutZAxis       Lib "gbstl.dll" Alias "stl_RotateAboutZAxis" (Angle As Single)

Declare Sub stl_CreateCube             Lib "gbstl.dll" Alias "stl_CreateCube"
Declare Sub stl_CreateSphere           Lib "gbstl.dll" Alias "stl_CreateSphere"
Declare Sub stl_LoadObjectFromFile     Lib "gbstl.dll" Alias "stl_LoadObjectFromFile" (FileName As String)
Declare Sub stl_LoadBGImage            Lib "gbstl.dll" Alias "stl_LoadBGImage" (fName As StringZ)

Declare Function stl_GetDLLVersion     Lib "gbstl.dll" Alias "stl_GetDLLVersion" () As String
Declare Function stl_GetPointCount     Lib "gbstl.dll" Alias "stl_GetPointCount" () As Long
Declare Function stl_GetTriangleCount  Lib "gbstl.dll" Alias "stl_GetTriangleCount" () As Long

Declare Sub      stl_GetDataPointers   Lib "gbstl.dll" Alias "stl_GetDataPointers" (d1 As Dword, pDims As Long, d2 As Dword, tDims As Long)

Declare Sub stl_MoveLeft               Lib "gbstl.dll" Alias "stl_MoveLeft"
Declare Sub stl_MoveRight              Lib "gbstl.dll" Alias "stl_MoveRight"
Declare Sub stl_MoveUp                 Lib "gbstl.dll" Alias "stl_MoveUp"
Declare Sub stl_MoveDown               Lib "gbstl.dll" Alias "stl_MoveDown"

Declare Sub stl_SetGradientDir            Lib "gbstl.dll" Alias "stl_SetGradientDir" (GradientDirection As Long)
Declare Sub stl_SetPointGradientColors    Lib "gbstl.dll" Alias "stl_SetPointGradientColors"
Declare Sub stl_SetTriangleGradientColors Lib "gbstl.dll" Alias "stl_SetTriangleGradientColors"

Enum Equates Singular
   IDC_Graphic = 500
   IDC_Toolbar
   IDC_ListView

   IDT_Open
   IDT_Reset
   IDT_Spin
   IDT_Copy
   IDT_Lines
   IDT_Points
   IDT_Surface
   IDT_X
   IDT_Y
   IDT_Z
   IDT_ShowData
   IDT_ShowBGImage
   IDT_Settings
   IDT_Help

   IDT_Gradient

   IDM_Test

   IDM_Left
   IDM_Right
   IDM_Up
   IDM_Down
   IDM_GradientDir

   IDM_NextModel
   IDM_PreviousModel

'   IDM_PlusZ
'   IDM_MinusZ

   IDM_Cube
   IDM_Sphere
   IDM_File

   IDM_BGColor
   IDM_PointColor
   IDM_LineColor
   IDM_TriangleColor
   IDM_ResetColors
   IDM_SetDefaultColors
   IDM_PointSize
   IDM_MoveDistance
'   IDM_ScaleZ
   IDM_Angle
   IDM_Interval
   IDM_ShowTime
   IDM_SelectBGImage

   IDM_Timer
   IDM_Sep
   IDM_ShowMarkers
   IDM_BGImageFit
   IDM_SurfaceLines
   IDM_BackFaceCull
   IDM_DepthSort
   IDM_Orthographic
   IDM_AsIsData

   PreDraw          = 1000
   PostDraw         = 1001
   PointersChanged  = 1002
   Startup          = 1003

   Shape_Cube = 1
   Shape_Sphere
   Shape_File

   Details_Points = 1
   Details_Lines
   Details_Surfaces

   GradientX = 1
   GradientY
   GradientZ
   GradientXR
   GradientYR
   GradientZR
End Enum

Global hDlg,hGraphic,hToolbar,hSettings,ghHook,hListView As Dword
Global Equation, BGImage As StringZ * %Max_Path
Global RotateX, RotateY, RotateZ, Interval As Long, Angle As Single
Global SpinInWork, XLast, YLast, XDelta, YDelta As Long
Global Spin, ShowData, AsIsData, ShowTime As Long
Global CustomColorList As CustomColors
Global DefLineColor, DefBGColor, DefPointColor, DefTriangleColor As Long
Global qFreq, qStart, qStop As Quad, STL As STLData
Global pPtr As PointX Ptr, tPtr As TriangleX Ptr, pDims, tDims As Long

Macro Pi = 3.141592653589793##

Function PBMain() As Long
   Local style&
   style& = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll Or %ES_AutoHScroll _
         Or %WS_HScroll Or %ES_AutoVScroll Or %ES_WantReturn Or %ES_NoHideSel Or %WS_TabStop
   Dialog Default Font "Tahoma", 10, 1
   Dialog New Pixels, 0, "gbSTL Demo",300,300,400,400, %WS_OverlappedWindow Or %WS_ClipChildren To hDlg
   STL.hParent = hDlg
   Dialog Set Icon hDlg, "logo"
   DragAcceptFiles hDlg, %True
   Control Add Graphic, hDlg, %IDC_Graphic,"", 5,65,200,200, %SS_Notify Or %WS_Border
   Control Handle hDlg, %IDC_Graphic To hGraphic
   Graphic Attach hDlg, %IDC_Graphic, ReDraw
   Graphic Get DC To STL.hParentDC
   CreateToolbar
   CreateContextMenus
   CreateListView

   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local i,x,y,iReturn,iRow,iCol As Long, temp$, tmp$$, pt As Point
   Local nmtb As TBNOTIFY Ptr, rc As RECT, PTT As TOOLTIPTEXTW Ptr,  pLVDI As LV_DISPINFOW Ptr
   Local tempP As PointX, tempT As TriangleX, d1,d2 As Dword

   Select Case Cb.Msg
      Case %WM_InitDialog
         If IsFolder (Exe.Path$ + "stl_models") = %False Then MkDir Exe.Path$ + "stl_models"
         If IsFolder (Exe.Path$ + "bgimages") = %False Then MkDir Exe.Path$ + "bgimage"
         QueryPerformanceFrequency qFreq
         BuildAcceleratorTable
         Settings_INI "get"
         If IsFile(BGImage) Then stl_LoadBGImage BGImage
         If IsFalse IsFile(STL.CFN) Then STL.Shape = %Shape_Sphere : STL.CFN = ""
         If Spin Then SetTimer hDlg, %IDM_Timer, Interval, ByVal %Null
         OpenSTLModel

         Dialog Post hDlg, %WM_User + %Startup, 0, 0
         Dialog Post hDlg, %WM_User + %PointersChanged, 0, 0

      Case %WM_User + %Startup
'         stl_RotateAboutXAxis pi
'         RenderSTL

      Case %WM_User + %PreDraw          'msg from DLL saying that a draw of the STL image is about to take place
                                      'host can respond by modifying P() and T()

      Case %WM_User + %PostDraw         'msg from DLL saying that a draw of the STL image has completed
                                      'main EXE can now draw on the graphic control

      Case %WM_User+%PointersChanged  'msg from DLL saying that the pointers to the P() and T() arrays have changed
         stl_GetDataPointers d1, pDims, d2, tDims  'host can respond by asking for the new pointers
         ListView_SetItemCountEx(hListView, pDims + tDims, %LVSICF_noInvalidateAll) 'max rows
         pPTR = d1 : tPTR = d2

      Case %WM_Destroy
         Settings_INI "save"

      Case %WM_DROPFILES
         temp$ = GetDroppedFileName(Cb.WParam)
         DragFinish Cb.WParam
         If IsFile(temp$) Then
            If InStr(".stl.stla.stlb",LCase$(PathName$(Extn,temp$))) Then
               STL.CFN = temp$
               STL.Shape = %Shape_File
               OpenSTLModel
            End If
         End If

      Case %WM_MouseWheel
         Select Case Hi(Integer,Cb.WParam)    'note the use of Integer
           Case > 0  : stl_ChangeSize(+0.05) : RenderSTL
           Case < 0  : stl_ChangeSize(-0.05) : RenderSTL
         End Select

      Case %WM_SetCursor
         'monitors the 3 basic splitter bar mouse actions, lbuttondown, mousemose, lbuttonup
         Select Case Hi(Word, Cb.LParam)
            Case %WM_LButtonDown
               iReturn = GetDlgCtrlID (Cb.WParam)
               If iReturn = %IDC_Graphic Then
                  SpinInWork = 1
                  GetCursorPos pt                   'pt has xy screen coordinates
                  ScreenToClient hGraphic, pt       'pt now has dialog client coordinates
                  XLast = Pt.x
                  YLast = Pt.y
               End If
            Case %WM_MouseMove
               If SpinInWork Then
                  GetCursorPos pt                   'pt has xy screen coordinates
                  ScreenToClient hGraphic, pt       'pt now has dialog client coordinates
                  XDelta = XLast - Pt.x
                  YDelta = YLast - Pt.y
                  If YDelta And RotateY Then stl_RotateAboutXAxis YDelta * 0.02      : RenderSTL : If ShowData Then  Control ReDraw hDlg, %IDC_ListView
                  If XDelta And RotateX Then stl_RotateAboutYAxis XDelta * 0.02 * -1 : RenderSTL : If ShowData Then  Control ReDraw hDlg, %IDC_ListView
                  XLast = pt.x
                  YLast = pt.y
               End If
            Case %WM_LButtonUp
               SpinInWork = 0
               Control Set Focus hDlg, %IDC_Toolbar
         End Select

      Case %WM_Timer
         If RotateX Then stl_RotateAboutXAxis Angle
         If RotateY Then stl_RotateAboutYAxis Angle
         If RotateZ Then stl_RotateAboutZAxis Angle
         RenderSTL
         If ShowData Then Control ReDraw hDlg, %IDC_ListView

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDM_Test : stl_RotateAboutXAxis Pi      : RenderSTL : If ShowData Then Control ReDraw hDlg, %IDC_ListView

            Case %IDT_Open       : SelectFileToOpen
            Case %IDT_Reset
               stl_Reset
               ResizeWindow
               stl_RotateAboutXAxis Pi
               RenderSTL
               If ShowData Then Control ReDraw hDlg, %IDC_ListView

            Case %IDT_Spin
               KillTimer hDlg, %IDM_Timer
               Spin Xor=1
               If Spin Then SetTimer hDlg, %IDM_Timer, Interval, ByVal %Null

            Case %IDT_X       : RotateX Xor=1
            Case %IDT_Y       : RotateY Xor=1
            Case %IDT_Z       : RotateZ Xor=1


            Case %IDT_Copy    : Clipboard Reset        : Clipboard Set Bitmap hGraphic

            Case %IDT_Points  : STL.Details = %Details_Points   : RenderSTL : SetMenusAndToolbar
            Case %IDT_Lines   : STL.Details = %Details_Lines    : RenderSTL : SetMenusAndToolbar
            Case %IDT_Surface : STL.Details = %Details_Surfaces : RenderSTL : SetMenusAndToolbar

            Case %IDT_Gradient     : STL.Gradient Xor=1 : RenderSTL
            Case %IDT_ShowBGImage  : STL.ShowBGImage Xor=1 : RenderSTL : SetMenusAndToolbar

            Case %IDT_ShowData
               ShowData Xor=1
               ResizeWindow : RenderSTL
               SetMenusAndToolbar

            Case %IDT_Settings : ShowSettings
            Case %IDT_Help
                 temp$ = "http://www.garybeene.com/sw/gbstl.htm"
                 i = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

            Case %IDM_Left    : stl_MoveLeft  : RenderSTL
            Case %IDM_Right   : stl_MoveRight : RenderSTL
            Case %IDM_Up      : stl_MoveUp    : RenderSTL
            Case %IDM_Down    : stl_MoveDown  : RenderSTL

            Case %IDM_NextModel
               If IsFalse IsFile(STL.CFN) Then STL.CFN = Exe.Path$ + "stl_models\" + Dir$(Exe.Path$ + "stl_models\*.*")
               STL.Shape = %Shape_File
               STL.CFN = CycleThroughFilesInFolder(+1, (STL.CFN), ".stl.stla.stlb")  'Forward/Next
               OpenSTLModel

            Case %IDM_PreviousModel
               If IsFalse IsFile(STL.CFN) Then STL.CFN = Exe.Path$ + "stl_models\" + Dir$(Exe.Path$ + "stl_models\*.*")
               STL.Shape = %Shape_File
               STL.CFN = CycleThroughFilesInFolder(-1, (STL.CFN), ".stl.stla.stlb")  'Forward/Next
               OpenSTLModel

'            Case %IDM_ScaleZ
'              Dialog Get Loc hDlg To x,y
'              ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
'              temp$ = InputBox$("", "Z Scale Factor (0-n)", Str$(STL.ScaleZ), x+100,y+100)
'              UnhookWindowsHookEx ghHook
'              STL.ScaleZ = Max(0,Val(temp$))
'              stl_ChangeZ STL.ScaleZ
'              stl_ScaleToFit
'              RenderSTL
'              SetMenusAndToolbar

'            Case %IDM_PlusZ
'               stl_ChangeZ 2
'               stl_ScaleToFit
'               RenderSTL
'               SetMenusAndToolbar

'            Case %IDM_MinusZ
'               STL.ScaleZ = 2
'               stl_ScaleToFit
'               stl_ChangeZ STL.ScaleZ
'               RenderSTL
'               SetMenusAndToolbar

            Case %IDM_Cube   : STL.Shape = %Shape_Cube   : OpenSTLModel
            Case %IDM_Sphere : STL.Shape = %Shape_Sphere : OpenSTLModel
            Case %IDM_File   : STL.Shape = %Shape_File   : OpenSTLModel

            Case %IDM_ShowTime
               ShowTime Xor=1
               If ShowTime = 0 Then
                  Dialog Set Text hDlg, "gbSTL Demo  v" + $Ver + "   DLL v" + stl_GetDLLVersion + "     " + Choose$(STL.Shape,"<Cube>","<Sphere>",STL.CFN)
               Else
                  RenderSTL
               End If

            Case %IDM_BGImageFit    : STL.BGImageFit Xor=1  : RenderSTL : SetMenusAndToolbar


            Case %IDM_PointColor    : STL.PointColor = SelectColor(STL.PointColor)       : RenderSTL
            Case %IDM_LineColor     : STL.LineColor = SelectColor(STL.LineColor)         : RenderSTL
            Case %IDM_TriangleColor : STL.TriangleColor = SelectColor(STL.TriangleColor) : RenderSTL
            Case %IDM_BGColor       : STL.BGColor = SelectColor(STL.BGColor)             : RenderSTL

            Case %IDM_SelectBGImage  : SelectBGImage

            Case %IDM_ResetColors
               STL.BGColor    = DefBGColor
               STL.PointColor = DefPointColor
               STL.LineColor  = DefLineColor
               STL.TriangleColor = DefTriangleColor
               RenderSTL
            Case %IDM_SetDefaultColors
               DefBGColor = STL.BGColor
               DefPointColor = STL.PointColor
               DefLineColor = STL.LineColor
               DefTriangleColor = STL.TriangleColor

            Case %IDM_ShowMarkers   : STL.ShowMarkers Xor=1  : RenderSTL : SetMenusAndToolbar
            Case %IDM_SurfaceLines  : STL.SurfaceLines Xor=1 : RenderSTL : SetMenusAndToolbar
            Case %IDM_BackFaceCull  : STL.BackFaceCull Xor=1 : RenderSTL : SetMenusAndToolbar
            Case %IDM_DepthSort     : STL.DepthSort Xor=1    : RenderSTL : SetMenusAndToolbar
            Case %IDM_Orthographic  : STL.Orthographic Xor=1 : RenderSTL : SetMenusAndToolbar
            Case %IDM_AsIsData      : AsIsData Xor=1         : SetMenusAndToolbar

            Case %IDM_MoveDistance
              Dialog Get Loc hDlg To x,y
              ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
              temp$ = InputBox$("", "Move Distance", Str$(STL.MoveDistance), x+100,y+100)
              UnhookWindowsHookEx ghHook
              If Len(temp$) Then
                 STL.MoveDistance = Val(temp$)
                 If STL.MoveDistance < 1 Then STL.MoveDistance = 1
                 RenderSTL
                 SetMenusAndToolbar
              End If

            Case %IDM_PointSize
              Dialog Get Loc hDlg To x,y
              ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
              temp$ = InputBox$("", "Point Size", Str$(STL.PointSize), x+100,y+100)
              UnhookWindowsHookEx ghHook
              If Len(temp$) Then
                 STL.PointSize = Val(temp$)
                 If STL.PointSize < 1 Then STL.PointSize = 1
                 RenderSTL
                 SetMenusAndToolbar
              End If

            Case %IDM_GradientDir
               Incr STL.GradientDir
               If STL.GradientDir > %GradientZR Then STL.GradientDir = %GradientX
               stl_SetGradientDir STL.GradientDir
               stl_SetPointGradientColors
               stl_SetTriangleGradientColors
               RenderSTL
               SetMenusAndToolbar
               Dialog Set Text hDlg, "gbSTL Demo  v" + $Ver + "   DLL v" + stl_GetDLLVersion + "     " + Choose$(STL.Shape,"<Cube>","<Sphere>",STL.CFN)


            Case %IDM_Interval
              Dialog Get Loc hDlg To x,y
              ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
              temp$ = InputBox$("", "Spin Step Interval", Str$(Interval), x+100,y+100)
              UnhookWindowsHookEx ghHook
              If Len(temp$) Then
                 Interval = Val(temp$)
                 If Interval < 10 Then Interval = 10
                 If Spin Then
                    KillTimer hDlg, %IDM_Timer
                    SetTimer hDlg, %IDM_Timer, Interval, ByVal %Null
                 End If
                 SetMenusAndToolbar
              End If

            Case %IDM_Angle
              Dialog Get Loc hDlg To x,y
              ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
              temp$ = InputBox$("", "Spin Step Angle", Str$(Angle), x+100,y+100)
              UnhookWindowsHookEx ghHook
              If Len(temp$) Then
                 Angle = Val(temp$)
                 RenderSTL
                 SetMenusAndToolbar
              End If

         End Select

      Case %WM_Notify
         Select Case Cb.NmId
            Case %IDC_ListView
               Select Case Cb.NmCode
                  Case %LVN_GetDispInfo             'notification to ask for data
                     If ShowData Then
                        pLVDI = Cb.LParam              'pointer to LVDISPINFO structure for requested subitem
                        iRow  = @pLVDI.item.iItem+1
                        iCol  = @pLVDI.item.iSubItem+1
                        If iRow > pDims Then
                           tempT = @tPtr[iRow-pDims]
                           Select Case iCol
                              Case 1 : tmp$$ = Str$(tempT.p1)
                              Case 2 : tmp$$ = Str$(tempT.p2)
                              Case 3 : tmp$$ = Str$(tempT.p3)
                              Case 4 : tmp$$ = Str$(GetRValue(tempT.ColorG))
                              Case 5 : tmp$$ = Str$(GetGValue(tempT.ColorG))
                              Case 6 : tmp$$ = Str$(GetBValue(tempT.ColorG))
                           End Select
                        Else
                           tempP = @pPtr[iRow]
                           Select Case iCol
                              Case 1 : tmp$$ = Format$(IIf(AsIsData,tempP.x,tempP.xo),"0.0")
                              Case 2 : tmp$$ = Format$(IIf(AsIsData,tempP.y,tempP.yo),"0.0")
                              Case 3 : tmp$$ = Format$(IIf(AsIsData,tempP.z,tempP.zo),"0.0")
                              Case 4 : tmp$$ = Str$(GetRValue(tempP.ColorG))
                              Case 5 : tmp$$ = Str$(GetGValue(tempP.ColorG))
                              Case 6 : tmp$$ = Str$(GetBValue(tempP.ColorG))
                           End Select
                        End If
                        @pLVDI.item.pszText = StrPtr(tmp$$)
                     End If
               End Select
            Case %IDT_Open To %IDT_Help
               Select Case Cb.NmCode
                  Case %TTN_GetDispInfoW
                     PTT = Cb.LParam
                     @PTT.@lpszText = SetToolTips(Cb.NmId)
               End Select
            Case %IDC_Toolbar
               Select Case Cb.NmCode
                   Case %TBN_DROPDOWN
                       nmtb = Cb.LParam
                       Select Case @nmtb.iItem
                           Case %IDT_Settings
                               Control Send hDlg, %IDC_Toolbar, %TB_GETRECT, %IDT_Settings, VarPtr(rc)
                               MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                               TrackPopupMenu (hSettings, 0, rc.nLeft, rc.nBottom, 0, hDlg, ByVal %NULL)
                       End Select
               End Select
         End Select
      Case %WM_Size : ResizeWindow : RenderSTL
   End Select
End Function

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(8)
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_Left     : ac(c).cmd   = %IDM_Left       : Incr c
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_Right    : ac(c).cmd   = %IDM_Right      : Incr c
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_Up       : ac(c).cmd   = %IDM_Up         : Incr c
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_Down     : ac(c).cmd   = %IDM_Down       : Incr c
'   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_Add      : ac(c).cmd   = %IDM_PlusZ      : Incr c
'   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_Subtract : ac(c).cmd   = %IDM_MinusZ     : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_G : ac(c).cmd   = %IDM_GradientDir       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_N : ac(c).cmd   = %IDM_NextModel         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_P : ac(c).cmd   = %IDM_PreviousModel     : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_T : ac(c).cmd   = %IDM_ShowTime          : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_Z : ac(c).cmd   = %IDM_Test              : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Function SelectColor(startcolor&) As Long    'works on pControl
   Local ColorResult&
   Display Color hDlg, 200, 200, startcolor&, CustomColorList ,0 To ColorResult&
   If ColorResult& = -1 Then Function = startcolor& Else Function = ColorResult&
End Function

Sub Settings_INI(Task$)
   Local x, y As Long
   Local xResult, yResult, INIFileName, temp As WStringZ * %Max_Path

   'defines file name (any file name will work)
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"

   'allows clearing of INI content by using application command tail:  'myapp.exe \clear'
   If InStr(Command$,"\clear") Then
      Kill INIFileName
   End If

   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "300", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "300", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "750", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "600", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variable
      Getprivateprofilestring "All", "CFN", "stl_models\ship.stla", temp, %Max_Path, INIFileName               : STL.CFN = temp
      Getprivateprofilestring "All", "BGImage", "bgimages\stars.jpg", temp, %Max_Path, INIFileName              : BGImage = temp
      Getprivateprofilestring "All", "Equation", "z=y*sin(x):1:10:.01:1:10:.01::", temp, %Max_Path, INIFileName : Equation = temp

      'get value for numeric variables
      Getprivateprofilestring "All", "Spin", Str$(0), temp, %Max_Path, INIFileName                    : Spin = Val(temp)
      Getprivateprofilestring "All", "Interval", Str$(50), temp, %Max_Path, INIFileName               : Interval = Val(temp)
      Getprivateprofilestring "All", "PointSize", Str$(2), temp, %Max_Path, INIFileName               : STL.PointSize = Val(temp)
'      Getprivateprofilestring "All", "ScaleZ", Str$(0), temp, %Max_Path, INIFileName                  : STL.ScaleZ = Val(temp)

      Getprivateprofilestring "All", "ShowBGImage", "1", temp, %Max_Path, INIFileName                 : STL.ShowBGImage = Val(temp)
      Getprivateprofilestring "All", "BGImageFit", "1", temp, %Max_Path, INIFileName                  : STL.BGImageFit = Val(temp)
      Getprivateprofilestring "All", "BGColor", Str$(%rgb_LightGray), temp, %Max_Path, INIFileName    : STL.BGColor = Val(temp)
      Getprivateprofilestring "All", "PointColor", Str$(%Blue), temp, %Max_Path, INIFileName          : STL.PointColor = Val(temp)
      Getprivateprofilestring "All", "LineColor", Str$(%Black), temp, %Max_Path, INIFileName          : STL.LineColor = Val(temp)
      Getprivateprofilestring "All", "TriangleColor", Str$(%rgb_Maroon), temp, %Max_Path, INIFileName : STL.TriangleColor = Val(temp)
      Getprivateprofilestring "All", "DefBGColor", Str$(%rgb_LightGray), temp, %Max_Path, INIFileName : DefBGColor = Val(temp)
      Getprivateprofilestring "All", "DefPointColor", Str$(%Blue), temp, %Max_Path, INIFileName       : DefPointColor = Val(temp)
      Getprivateprofilestring "All", "DefLineColor", Str$(%Black), temp, %Max_Path, INIFileName       : DefLineColor = Val(temp)
      Getprivateprofilestring "All", "DefTriangleColor", Str$(%rgb_Maroon), temp, %Max_Path, INIFileName : DefTriangleColor = Val(temp)

      Getprivateprofilestring "All", "ShowTime", "0", temp, %Max_Path, INIFileName                    : ShowTime = Val(temp)
      Getprivateprofilestring "All", "Details", Str$(%Details_Surfaces), temp, %Max_Path, INIFileName : STL.Details = Val(temp)   '1=Points  2=Lines  3=Surface
      Getprivateprofilestring "All", "Shape", Str$(%Shape_Sphere), temp, %Max_Path, INIFileName       : STL.Shape = Val(temp)        '1=Box  2=Sphere  3=File
      Getprivateprofilestring "All", "Gradient", "1", temp, %Max_Path, INIFileName                    : STL.Gradient = Val(temp)
      Getprivateprofilestring "All", "GradientDir", Str$(%GradientZ), temp, %Max_Path, INIFileName    : STL.GradientDir = Val(temp)
      Getprivateprofilestring "All", "BackFaceCull", "1", temp, %Max_Path, INIFileName                : STL.BackFaceCull = Val(temp)
      Getprivateprofilestring "All", "DepthSort", "1", temp, %Max_Path, INIFileName                   : STL.DepthSort = Val(temp)
      Getprivateprofilestring "All", "Orthographic", "1", temp, %Max_Path, INIFileName                : STL.Orthographic = Val(temp)
      Getprivateprofilestring "All", "AsIsData", "1", temp, %Max_Path, INIFileName                    : AsIsData = Val(temp)
      Getprivateprofilestring "All", "RotateX", "1", temp, %Max_Path, INIFileName                     : RotateX = Val(temp)
      Getprivateprofilestring "All", "RotateY", "1", temp, %Max_Path, INIFileName                     : RotateY = Val(temp)
      Getprivateprofilestring "All", "RotateZ", "1", temp, %Max_Path, INIFileName                     : RotateZ = Val(temp)
      Getprivateprofilestring "All", "Angle", "0.02", temp, %Max_Path, INIFileName                    : Angle = Val(temp)
      Getprivateprofilestring "All", "ShowMarkers", "0", temp, %Max_Path, INIFileName                 : STL.ShowMarkers = Val(temp)
      Getprivateprofilestring "All", "MoveDistance", "1", temp, %Max_Path, INIFileName                : STL.MoveDistance = Val(temp)
      Getprivateprofilestring "All", "ShowData", "0", temp, %Max_Path, INIFileName                    : ShowData = Val(temp)
      Getprivateprofilestring "All", "SurfaceLines", "1", temp, %Max_Path, INIFileName                : STL.SurfaceLines = Val(temp)

      'custom colors
      For x = 0 To 15
         Getprivateprofilestring "All", "CustomColorC" + Format$(x,"00"), "", temp, %Max_Path, INIFileName
         CustomColorList.c(x) = Val(temp)
      Next x
   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If

      'save string variables
      WritePrivateProfileString "All", "CFN", (STL.CFN), INIFileName
      WritePrivateProfileString "All", "BGImage", (BGImage), INIFileName
      WritePrivateProfileString "All", "Equation", (Equation), INIFileName

      'save numeric variable
      WritePrivateProfileString "All", "Spin", Str$(Spin), INIFileName
      WritePrivateProfileString "All", "Interval", Str$(Interval), INIFileName
      WritePrivateProfileString "All", "PointSize", Str$(STL.PointSize), INIFileName
'      WritePrivateProfileString "All", "ScaleZ", Str$(STL.ScaleZ), INIFileName

      WritePrivateProfileString "All", "ShowBGImage", Str$(STL.ShowBGImage), INIFileName
      WritePrivateProfileString "All", "BGImageFit", Str$(STL.BGImageFit), INIFileName
      WritePrivateProfileString "All", "BGColor", Str$(STL.BGColor), INIFileName
      WritePrivateProfileString "All", "PointColor", Str$(STL.PointColor), INIFileName
      WritePrivateProfileString "All", "LineColor", Str$(STL.LineColor), INIFileName
      WritePrivateProfileString "All", "TriangleColor", Str$(STL.TriangleColor), INIFileName

      WritePrivateProfileString "All", "DefBGColor", Str$(DefBGColor), INIFileName
      WritePrivateProfileString "All", "DefPointColor", Str$(DefPointColor), INIFileName
      WritePrivateProfileString "All", "DefLineColor", Str$(DefLineColor), INIFileName
      WritePrivateProfileString "All", "DefTriangleColor", Str$(DefTriangleColor), INIFileName

      WritePrivateProfileString "All", "ShowTime", Str$(ShowTime), INIFileName
      WritePrivateProfileString "All", "Details", Str$(STL.Details), INIFileName
      WritePrivateProfileString "All", "Shape", Str$(STL.Shape), INIFileName
      WritePrivateProfileString "All", "Gradient", Str$(STL.Gradient), INIFileName
      WritePrivateProfileString "All", "GradientDir", Str$(STL.GradientDir), INIFileName
      WritePrivateProfileString "All", "BackFaceCull", Str$(STL.BackFaceCull), INIFileName
      WritePrivateProfileString "All", "DepthSort", Str$(STL.DepthSort), INIFileName
      WritePrivateProfileString "All", "Orthographic", Str$(STL.Orthographic), INIFileName
      WritePrivateProfileString "All", "AsIsData", Str$(AsIsData), INIFileName
      WritePrivateProfileString "All", "RotateX", Str$(RotateX), INIFileName
      WritePrivateProfileString "All", "RotateY", Str$(RotateY), INIFileName
      WritePrivateProfileString "All", "RotateZ", Str$(RotateZ), INIFileName
      WritePrivateProfileString "All", "Angle", Str$(Angle), INIFileName
      WritePrivateProfileString "All", "ShowMarkers", Str$(STL.ShowMarkers), INIFileName
      WritePrivateProfileString "All", "MoveDistance", Str$(STL.MoveDistance), INIFileName
      WritePrivateProfileString "All", "ShowData", Str$(ShowData), INIFileName
      WritePrivateProfileString "All", "SurfaceLines", Str$(STL.SurfaceLines), INIFileName

      'custom colors
      For x = 0 To 15
         temp = Str$(CustomColorList.c(x))
         WritePrivateProfileString "All", "CustomColorC" + Format$(x,"00"), temp, INIFileName
      Next
   End If

End Sub

Sub SelectFileToOpen
   Local filter$, startfile$, startfolder$
   Local defaultext$, flags&, filevar$, countvar&
   filter$ = Chr$("STL Files",0,"*.stl;*.stla;*.stlb",0)
   startfolder$ = IIf$(IsFolder(PathName$(Path, STL.CFN)), PathName$(Path, STL.CFN), Exe.Path$ + "stl_Models")
   startfile$ = PathName$(Namex, STL.CFN)
   defaultext$  = "stl"  'default extension to append to selection if user does not enter it
   flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
   Display Openfile hDlg, 100, 100, "", startfolder$, filter$, (startfile$), defaultext$, flags& To filevar$, countvar&
   If IsFile(filevar$) Then
      STL.CFN = filevar$
      STL.Shape = %Shape_File
      OpenSTLModel
   End If
End Sub

Sub ResizeWindow
   Local w,h As Long
   If IsIconic(hDlg) Then Exit Sub
   Dialog Get Client hDlg To w,h
   If ShowData Then
      Control Set Loc hDlg, %IDC_ListView, 5,60
      Control Set Size hDlg, %IDC_ListView, 200,h-65
      Control Set Loc hDlg, %IDC_Graphic, 210,60
      Graphic Set Client w-215,h-65
      stl_ResizeImage w-215, h-65
   Else
      Control Set Loc hDlg, %IDC_ListView, -500,60
      Graphic Set Client w-10,h-65
      Control Set Loc hDlg, %IDC_Graphic, 5,60
      stl_ResizeImage w-10, h-65
   End If
   stl_SetPointHighLow
   stl_CenterModel
   stl_ScaleToFit
End Sub

Sub CreateListView
   Control Add ListView, hDlg, %IDC_ListView,"", 5,65,100,100,%WS_Child Or %WS_TabStop Or %WS_Visible Or %LVS_ShowSelAlways Or %LVS_Report Or %LVS_OwnerData Or %LVS_ShowSelAlways Or %LVS_SingleSel
   Control Handle hDlg, %IDC_ListView To hListView                   'handle to ListView
   ListView Insert Column hDlg, %IDC_Listview, 1, "X", 64,0     'set headers
   ListView Insert Column hDlg, %IDC_Listview, 2, "Y", 64,0     'set headers
   ListView Insert Column hDlg, %IDC_Listview, 3, "Z", 64,0     'set headers
   ListView Insert Column hDlg, %IDC_Listview, 4, "R", 45,0     'set headers
   ListView Insert Column hDlg, %IDC_Listview, 5, "G", 45,0     'set headers
   ListView Insert Column hDlg, %IDC_Listview, 6, "B", 45,0     'set headers
   ListView_SetItemCountEx(hListView, 10, %LVSICF_noInvalidateAll) 'max rows
   SendMessage (hListView, %WM_NOTIFYFORMAT, hDlg, %NF_REQUERY)
End Sub

Sub CreateToolbar
    Local hLst As Dword

    Control Add Toolbar, hDlg, %IDC_Toolbar, "Toolbar",0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_ClipSiblings Or %WS_Child
    Control Send hDlg, %IDC_Toolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS   'allow dropdown arrow buttons
    Control Handle hDlg, %IDC_Toolbar To hToolbar

     'create imagelist
     ImageList New Icon 24,24,32,30 To hLst
     ImageList Add Icon hLst, "xopen"       '1
     ImageList Add Icon hLst, "xreset"      '2
     ImageList Add Icon hLst, "xcopy"       '3
     ImageList Add Icon hLst, "xsettings"   '4
     ImageList Add Icon hLst, "xhelp"       '5
     ImageList Add Icon hLst, "xpoints"     '6
     ImageList Add Icon hLst, "xlines"      '7
     ImageList Add Icon hLst, "xtriangles"  '8
     ImageList Add Icon hLst, "xx"          '9
     ImageList Add Icon hLst, "xy"          '10
     ImageList Add Icon hLst, "xz"          '11
     ImageList Add Icon hLst, "xgradient"   '12
     ImageList Add Icon hLst, "xspin"       '13
     ImageList Add Icon hLst, "xshowdata"   '14
     ImageList Add Icon hLst, "xrefresh"    '15
     ImageList Add Icon hLst, "ximage"      '16


     Toolbar Set ImageList hDlg, %IDC_Toolbar, hLst, 0

     'create buttons
     Toolbar Add Button  hDlg, %IDC_Toolbar, 1, %IDT_Open,  %TbStyle_Button, "Open"
     Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDT_Reset,  %TbStyle_Button, "Reset"
     Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDT_Copy,  %TbStyle_Button, "Copy"
     Toolbar Add Separator hDlg, %IDC_Toolbar, 20
     Toolbar Add Button  hDlg, %IDC_Toolbar, 13, %IDT_Spin,  %TbStyle_Check, "Spin"
     Toolbar Add Button  hDlg, %IDC_Toolbar, 9, %IDT_X,  %TbStyle_Check, "X"
     Toolbar Add Button  hDlg, %IDC_Toolbar, 10, %IDT_Y,  %TbStyle_Check, "Y"
     Toolbar Add Button  hDlg, %IDC_Toolbar, 11, %IDT_Z,  %TbStyle_Check, "Z"
     Toolbar Add Separator hDlg, %IDC_Toolbar, 20
     Toolbar Add Button  hDlg, %IDC_Toolbar, 6, %IDT_Points,  %TbStyle_CheckGroup, "Points"
     Toolbar Add Button  hDlg, %IDC_Toolbar, 7, %IDT_Lines,  %TbStyle_CheckGroup, "Lines"
     Toolbar Add Button  hDlg, %IDC_Toolbar, 8, %IDT_Surface,  %TbStyle_CheckGroup, "Surface"
     Toolbar Add Separator hDlg, %IDC_Toolbar, 20
     Toolbar Add Button  hDlg, %IDC_Toolbar, 14, %IDT_ShowData,  %TbStyle_Check, "Data"
     Toolbar Add Button  hDlg, %IDC_Toolbar, 16, %IDT_ShowBGImage,  %TbStyle_Check, "BG Image"
     Toolbar Add Button  hDlg, %IDC_Toolbar, 12, %IDT_Gradient,  %TbStyle_Check, "Gradient"
     Toolbar Add Button  hDlg, %IDC_Toolbar, 4, %IDT_Settings,  %TbStyle_Button Or %TbStyle_DropDown, "Settings"
     Toolbar Add Button  hDlg, %IDC_Toolbar, 5, %IDT_Help,   %TbStyle_Button, "Help"

End Sub

Sub SetMenusAndToolbar
   'Menu Text
'   Menu Set Text hSettings, ByCmd %IDM_ScaleZ, "Z Scale Factor  (" + Format$(STL.ScaleZ,"0") + ") ..."
   Menu Set Text hSettings, ByCmd %IDM_PointSize, "Point Size  (" + Format$(STL.PointSize,"0") + ") ..."
   Menu Set Text hSettings, ByCmd %IDM_Angle, "Rotation Angle  (" + Format$(Angle,"0.0") + ") ..."
   Menu Set Text hSettings, ByCmd %IDM_Interval, "Rotation Interval  (" + Format$(Interval,"0.0") + ") ..."
   Menu Set Text hSettings, ByCmd %IDM_MoveDistance, "Move Distance  (" + Format$(STL.MoveDistance,"0") + ") ..."
   Menu Set Text hSettings, ByCmd %IDM_File, "File:  " + PathName$(Namex,STL.CFN)


   'Visibility
   Control Show State hDlg, %IDC_ListView, IIf(ShowData, %SW_Show, %SW_Hide)

   'Toolbars
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_X,  RotateX * %TBState_Checked Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Y,  RotateY * %TBState_Checked Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Z,  RotateZ * %TBState_Checked Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Points,  IIf(STL.Details=%Details_Points,1,0) * %TBState_Checked Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Lines,   IIf(STL.Details=%Details_Lines,1,0) * %TBState_Checked Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Surface, IIf(STL.Details=%Details_Surfaces,1,0) * %TBState_Checked Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_ShowData, ShowData * %TBState_Checked Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_ShowBGImage, STL.ShowBGImage * %TBState_Checked Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Gradient, STL.Gradient * %TBState_Checked Or %TBState_Enabled

   'Menus
   Menu Set State hSettings, ByCmd %IDM_Cube, IIf(STL.Shape=%Shape_Cube,1,0) * %MFS_Checked Or %MFS_Enabled
   Menu Set State hSettings, ByCmd %IDM_Sphere, IIf(STL.Shape=%Shape_Sphere,1,0) * %MFS_Checked Or %MFS_Enabled
   Menu Set State hSettings, ByCmd %IDM_File, IIf(STL.Shape=%Shape_File,1,0) * %MFS_Checked Or %MFS_Enabled
   Menu Set State hSettings, ByCmd %IDM_ShowMarkers, STL.ShowMarkers * %MFS_Checked Or %MFS_Enabled
   Menu Set State hSettings, ByCmd %IDM_BGImageFit, STL.BGImageFit * %MFS_Checked Or %MFS_Enabled
   Menu Set State hSettings, ByCmd %IDM_SurfaceLines, STL.SurfaceLines * %MFS_Checked Or %MFS_Enabled
   Menu Set State hSettings, ByCmd %IDM_BackFaceCull, STL.BackFaceCull * %MFS_Checked Or %MFS_Enabled
   Menu Set State hSettings, ByCmd %IDM_DepthSort, STL.DepthSort * %MFS_Checked Or %MFS_Enabled
   Menu Set State hSettings, ByCmd %IDM_Orthographic, STL.Orthographic * %MFS_Checked Or %MFS_Enabled
   Menu Set State hSettings, ByCmd %IDM_AsIsData, AsIsData * %MFS_Checked Or %MFS_Enabled

End Sub

Function SetToolTips(cID As Long) As String
   Select Case cID         'or this:   @P.hdr.idFrom
      Case %IDT_Open          : Function = "Open Existing File"
      Case %IDT_Reset         : Function = "Redraw Image - No Rotation, Fit to Dialog"
      Case %IDT_Spin          : Function = "AutoRotate the Image"
      Case %IDT_X             : Function = "Allow Left/Right Rotation (About the Y Axis)"
      Case %IDT_Y             : Function = "Allow Top/Bottom Rotation (About the X Axis)"
      Case %IDT_Z             : Function = "Allow Clockwise/CounterClockwise Rotation (About the Z Axis)"
      Case %IDT_Copy          : Function = "Copy Image to Clipboard"
      Case %IDT_Points        : Function = "Display Points Only"
      Case %IDT_Lines         : Function = "Display Lines Only"
      Case %IDT_Surface       : Function = "Display Surfaces"
      Case %IDT_Gradient      : Function = "Use Gradient Colors"
      Case %IDT_ShowData      : Function = "Display Model Data"
      Case %IDT_Settings      : Function = "Settings"
      Case %IDT_Help          : Function = "Online Help"
   End Select
End Function

Sub CreateContextMenus
   Menu New PopUp To hSettings
   Menu Add String, hSettings, "Cube", %IDM_Cube, %MF_Enabled
   Menu Add String, hSettings, "Sphere", %IDM_Sphere, %MF_Enabled
   Menu Add String, hSettings, "File", %IDM_File, %MF_Enabled
   Menu Add String, hSettings, "-",  %IDM_Sep,  %MF_Enabled
   Menu Add String, hSettings, "Backface Culling", %IDM_BackFaceCull, %MF_Enabled
   Menu Add String, hSettings, "Depth Sort", %IDM_DepthSort, %MF_Enabled
'   Menu Add String, hSettings, "Orthographic Projection", %IDM_Orthographic, %MF_Enabled
   Menu Add String, hSettings, "-",  %IDM_Sep,  %MF_Enabled
   Menu Add String, hSettings, "Surface Lines", %IDM_SurfaceLines, %MF_Enabled
   Menu Add String, hSettings, "Markers (Points Only)", %IDM_ShowMarkers, %MF_Enabled
   Menu Add String, hSettings, "Current Position Data", %IDM_AsIsData, %MF_Enabled
   Menu Add String, hSettings, "-",  %IDM_Sep,  %MF_Enabled
   Menu Add String, hSettings, "Stretch BG Image", %IDM_BGImageFit, %MF_Enabled
   Menu Add String, hSettings, "Select BG Image ...", %IDM_SelectBGImage, %MF_Enabled
   Menu Add String, hSettings, "-",  %IDM_Sep,  %MF_Enabled
   Menu Add String, hSettings, "BG Color ...", %IDM_BGColor, %MF_Enabled
   Menu Add String, hSettings, "Point Color ...", %IDM_PointColor, %MF_Enabled
   Menu Add String, hSettings, "Line Color ...", %IDM_LineColor, %MF_Enabled
   Menu Add String, hSettings, "Surface Color ...", %IDM_TriangleColor, %MF_Enabled
   Menu Add String, hSettings, "-",  %IDM_Sep,  %MF_Enabled
   Menu Add String, hSettings, "Reset Colors", %IDM_ResetColors, %MF_Enabled
   Menu Add String, hSettings, "Use Current Colors as Defaults", %IDM_SetDefaultColors, %MF_Enabled
   Menu Add String, hSettings, "-",  %IDM_Sep,  %MF_Enabled
   Menu Add String, hSettings, "Point Size ...", %IDM_PointSize, %MF_Enabled
'   Menu Add String, hSettings, "Z Scale Factor ...", %IDM_ScaleZ, %MF_Enabled
   Menu Add String, hSettings, "Move Distance ...", %IDM_MoveDistance, %MF_Enabled
   Menu Add String, hSettings, "Rotation Angle ...", %IDM_Angle, %MF_Enabled
   Menu Add String, hSettings, "Rotation Interval ...", %IDM_Interval, %MF_Enabled
End Sub

Function InputBoxProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
   Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
   If nCode = %HCBT_CREATEWND Then
      cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
      cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
      GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
      If UCase$(szTemp) = "BUTTON" Then @cst.x = 120  : @cst.cx = 60           'ok and cancel
      If UCase$(szTemp) = "STATIC" Then @cst.x = 400                           'prompt
      If UCase$(szTemp) = "EDIT"   Then @cst.cx = 100 : @cst.y = @cst.y - 130  'textbox
      If UCase$(szTemp) = "EDIT"   Then SetWindowLong wparam, %GWL_Style, GetWindowLong(wParam,%GWL_Style)
      If UCase$(szTemp) = "#32770" Then @cst.cx = 200 : @cst.cy = @cst.cy - 130                'dialog
   End If
End Function

Sub ShowSettings
   Local temp$

   stl_GetDataPointers pPtr, pDims, tPtr, tDims  'host responds by asking for the new values

   temp$ = "Model Type: " + $Tab + Choose$(STL.Shape,"Cube","Sphere","File") + $CrLf

   temp$ += "Points: " + $Tab + $Tab + Format$(pDims, "###,###,##0") + $CrLf
   temp$ += "Triangles: " + $Tab + $Tab + Format$(tDims, "###,###,##0") + $CrLf + $CrLf

   temp$ += "BG Image: " + $Tab + PathName$(Namex,BGImage) + $CrLf + $CrLf

   temp$ += "Show Data" + $Tab + IIf$(ShowData,"On","Off") + $CrLf
   temp$ += "Auto Refresh Data" + $Tab + IIf$(ShowData,"On","Off") + $CrLf
   temp$ += "Current Data" + $Tab + IIf$(ShowData,"On","Off") + $CrLf + $CrLf

   temp$ += "Gradient" + $Tab + $Tab + IIf$(STL.Gradient,"On","Off") + $CrLf
   temp$ += "Surface Lines" + $Tab + IIf$(STL.SurfaceLines,"On","Off") + $CrLf
   temp$ += "Markers" + $Tab + $Tab + IIf$(STL.ShowMarkers,"On","Off") + $CrLf

   temp$ += "BackFace Cull" + $Tab + IIf$(STL.BackFaceCull,"On","Off") + $CrLf
   temp$ += "Depth Sort" + $Tab + IIf$(STL.DepthSort,"On","Off") + $CrLf + $CrLf
'   temp$ += "Orthographic" + $Tab + $Tab + IIf$(Orthographic,"On","Off") + $CrLf + $CrLf

   temp$ += "Point Size" + $Tab + $Tab + Str$(STL.PointSize) + $CrLf
   temp$ += "Gradient Direction" + $Tab + Str$(STL.GradientDir) + $CrLf
'   temp$ += "Z Scale Factor" + $Tab + Str$(STL.ScaleZ) + $CrLf
   temp$ += "Spin Step Angle" + $Tab + Str$(Angle) + $CrLf
   temp$ += "Spin Step Interval" + $Tab + Str$(Interval) + $CrLf + $CrLf

   temp$ += "Rotate X" + $Tab + $Tab + IIf$(RotateX,"On","Off") + $CrLf
   temp$ += "Rotate Y" + $Tab + $Tab + IIf$(RotateY,"On","Off") + $CrLf
   temp$ += "Rotate Z" + $Tab + $Tab + IIf$(RotateZ,"On","Off") + $CrLf

   MsgBox temp$, %MB_Ok + %MB_IconInformation, "gbSTL Demo Settings"
End Sub

Sub RenderSTL
   QueryPerformanceCounter qStart
   stl_Render STL
   Graphic ReDraw
   QueryPerformanceCounter qStop
   If ShowTime Then Dialog Set Text hDlg, Format$((qStop-qStart)/qFreq,"###.00000") & " seconds"
End Sub

Function GetDroppedFileName(hDrop As Dword) As String
   'David Gwillim July 2005
   Local fString As WStringZ*%Max_Path, Count As Long
   fString=Space$(%Max_Path)
   Count = DragQueryFileW(hDrop,0,fString,Len(fString)-1)  ' put FileName(0) into fString and get character count
   Function = Left$(fString,Count)                          ' put Count chars into result string
End Function

Function CycleThroughFilesInFolder(Direction As Long, CurrentFile$, ExtMask$) As String
   Local temp$, FilePath$, FileList$, i,iPos As Long
   'put all matching files in an array, LCase$ everything
   FilePath$ = LCase$(PathName$(Path,CurrentFile$))
   temp$ = LCase$(Dir$(FilePath$ + "*.*"))
   Do While Len(temp$)
      If InStr(ExtMask$,LCase$(PathName$(Extn,temp$))) Then FileList$ += FilePath$ + LCase$(temp$) + $CrLf
      temp$ = Dir$(Next)
   Loop
   FileList$ = Trim$(FileList$,$CrLf)
   ReDim FileArray(ParseCount(FileList$,$CrLf)-1) As String
   Parse FileList, FileArray(), $CrLf
   Array Sort FileArray()

   If UBound(FileArray) = 0 Then Function = CurrentFile$ : Exit Function 'there is only one file, so returns that fle

   'find current file in array
   temp$ = FilePath$ + LCase$(PathName$(Namex,CurrentFile$))
   For i = 0 To UBound(FileArray)
      If FileArray(i) = temp$ Then iPos = i : Exit For
   Next i

   'get file in specified direction
   If Direction = +1     Then  'Next 'get next item. if is last, go to first. if is only, return the same
      If iPos < UBound(FileArray) Then Function = FileArray(iPos+1) : Exit Function
      If iPos = UBound(FileArray) Then Function = FileArray(0)      : Exit Function
   ElseIf Direction = -1 Then  'Previous 'get previous item. if is first, go to last. if is only, return the same
      If iPos > 0 Then Function = FileArray(iPos-1)            : Exit Function
      If iPos = 0 Then Function = FileArray(UBound(FileArray)) : Exit Function
   End If
End Function

Sub OpenSTLModel
   stl_SetGradientDir STL.GradientDir
   Select Case STL.Shape
      Case %Shape_Cube   : stl_CreateCube
      Case %Shape_Sphere : stl_CreateSphere
      Case %Shape_File   : stl_LoadObjectFromFile((STL.CFN))
   End Select
   ResizeWindow
   stl_RotateAboutXAxis Pi
   RenderSTL
   SetMenusAndToolbar
   Dialog Set Text hDlg, "gbSTL Demo  v" + $Ver + "   DLL v" + stl_GetDLLVersion + "     " + Choose$(STL.Shape,"<Cube>","<Sphere>",STL.CFN)
End Sub

Sub SelectBGImage
   Local filter$, startfile$, startfolder$
   Local defaultext$, flags&, filevar$, countvar&
   filter$ = Chr$("Images",0,"*.bmp;*.png;*.gif;*.jpg",0)
   startfolder$ = Exe.Path$ + "bgimages"
   startfile$ = PathName$(Namex,BGImage)
   defaultext$  = "jpg"  'default extension to append to selection if user does not enter it
   flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
   Display Openfile hDlg, 100, 100, "", startfolder$, filter$, (startfile$), defaultext$, flags& To filevar$, countvar&
   If IsFile(filevar$) Then
      BGImage = filevar$
      stl_LoadBGImage BGImage
      RenderSTL
   End If
End Sub
